#!/usr/bin/python
#
# Progress bar for Update Agent
# Copyright (c) 2000, 2001 Red Hat, Inc.  Distributed under GPL.
#
# Author: Preston Brown <pbrown@redhat.com>
"""Progress bar for up2date"""

import gtk
import libglade
from GTK import TRUE, FALSE
from GDK import WATCH

class Progress:
    """A progress widget"""
    def __init__(self):
        self.xml = libglade.GladeXML("/usr/share/rhn/up2date_client/progress.glade", "progressWindow", domain="up2date")
        self.progressWindow = self.xml.get_widget("progressWindow")
        self.progressWindow.connect("delete_event", self.noop)
        self.progressWindow.connect("hide", self.progressWindow.hide)
        cursor = gtk.cursor_new (WATCH)
        self.progressWindow.get_window().set_cursor(cursor)
        while gtk.events_pending():
            gtk.mainiteration(FALSE)
        self.lastProgress = 0.0

    def destroy(self):
        while gtk.events_pending():
            gtk.mainiteration(FALSE)

        self.progressWindow.destroy()

    def noop(self, win, event):
        return TRUE

    def hide(self):
        self.progressWindow.hide()
        while gtk.events_pending():
            gtk.mainiteration(FALSE)
            
        del self

    def setLabel(self, text):
        label = self.xml.get_widget("progressLabel")
        label.set_text(text)
        while gtk.events_pending():
            gtk.mainiteration(FALSE)

    # the xmlrpc callbacks only use the first three
    # the GET style use all 4, so pass em but dont use them
    def setProgress(self, amount, total, speed = 0, secs = 0):
        if total:
            i = float(amount) / total
        else:
            i = 1

        if i > 1:
            i = 1
        if i > self.lastProgress + .01 or i == 1:
            self.xml.get_widget("progressBar").update(i)
            if i == 1:
                # reset
                i = 0
            gtk.gdk_flush()
            while gtk.events_pending():
                gtk.mainiteration(FALSE)
            self.lastProgress = i


        
